﻿-- Quiz by Bru and Hayward on Blackhand(DE)
-- Modified by Azonia on Cenarion Circle (US)
-- Repaired by 阿适 (NGA）
-- I will not be held responsible for anyone getting kicked, banned, pwn3d, or grounded for spamming in guild chat!
QUIZ_VERSION = "4.1";
QUIZVARIABLES_LOADED = false;
Quiz_Mod_Save = {};

QuizConfig = {
	channel = "quiz",
	channelType = "channel",
	pointsToWin = 10,
	pauseBetweenQuestions = 10,
	firstHint = 35,
	nextHint = 18,
	speed="medium",
	maxHints = 6,
	genre = "none",
	adminCommands = "on",
	admins = {},
	fortunes = "on",
    eightBall = "on"
}


-- constants
QUIZ_STATE_STOPPED = 1;
QUIZ_STATE_PAUSED = 2;
QUIZ_STATE_ASKING = 3;
QUIZ_STATE_WAITING_TO_ASK = 4;

Quiz_Slow_FirstHint = 70;
Quiz_Slow_NextHint = 36;
Quiz_Slow_PauseBetween = 20;

Quiz_Medium_FirstHint = 35;
Quiz_Medium_NextHint = 18;
Quiz_Medium_PauseBetween = 10;

Quiz_Fast_FirstHint = 17;
Quiz_Fast_NextHint = 9;
Quiz_Fast_PauseBetween = 5;

-- main temporary data table
QuizData = {
	score = {},
	state = QUIZ_STATE_STOPPED,
	lastAction = 0,
	questionNumber = 0,
	questionTable = {},
};


function Quiz_OnLoad()

	SlashCmdList["QUIZ"] = Quiz_SlashCommandHandler;
	SLASH_QUIZ1 = "/quiz";
	DEFAULT_CHAT_FRAME:AddMessage("WOW智力问答Ver"..QUIZ_VERSION.." 已加载 - /quiz");

end

function Quiz_SlashCommandHandler(command)
	if (not command) then
		return;
	end
	
	local args = {};

	for arg in string.gmatch(command, "%S+") do

		table.insert(args, arg);
	end

	if (args[1] == "start") then
		Quiz_CmdStart();
	elseif (args[1] == "pause") then
		Quiz_CmdPause();
	elseif (args[1] == "stop") then
		Quiz_CmdStop();
	elseif (args[1] == "resetscore") then
		Quiz_CmdResetScore();
	elseif (args[1] == "hint") then
		Quiz_CmdHint();
	elseif (args[1] == "solve") then
		Quiz_CmdSolve();
	elseif (args[1] == "stats") then
		Quiz_CmdStats();
	elseif (args[1] == "channel" and args[2]) then
		Quiz_CmdChannel(args[2]);
	elseif (args[1] == "pointstowin" and args[2]) then
		Quiz_CmdPointsToWin(args[2],0);
	elseif (args[1] == "maxhints" and args[2]) then
		Quiz_CmdMaxHints(args[2],0);
	elseif (args[1] == "changegenre" and args[2]) then
		local argsString = "";
		argsString = string.sub(command,(string.len(args[1])+2));
		Quiz_CmdChangeGenre(argsString,0);
	elseif (args[1] == "speed" and args[2]) then
		Quiz_CmdChangeSpeed(args[2]);
	elseif (args[1] == "showgenres") then
		Quiz_CmdShowGenres();
	elseif (args[1] == "makeadmin" and args[2]) then
		Quiz_CmdMakeAdmin(args[2]);
	elseif (args[1] == "removeadmin" and args[2]) then
		Quiz_CmdRemoveAdmin(args[2]);
	elseif (args[1] == "clearalladmins") then
		Quiz_CmdClearAllAdmins();
	elseif (args[1] == "showadmins") then
		Quiz_CmdShowAdmins();
	elseif (args[1] == "toggleadmincommands") then
		Quiz_CmdToggleAdminCommands();
	elseif (args[1] == "togglefortunes") then
		Quiz_CmdToggleFortunes();
	elseif (args[1] == "toggle8ball") then
		Quiz_CmdToggleEightBall();
	elseif (args[1] == "status") then
		Quiz_CmdStatus();
	elseif (args[1] == "clear") then
		Quiz_CmdClear();
	else
		Quiz_CmdHelp();
	end
end

function Quiz_OnEvent(self,event,arg1,arg2,...)

		local ct = QuizConfig.channelType;

		if (event == "CHAT_MSG_CHANNEL" and ct == "channel") then
			Quiz_ParseMessage(arg8, arg2, arg1);
		end
		if (event == "CHAT_MSG_RAID" and ct == "raid") then
			Quiz_ParseMessage("", arg2, arg1);
		end
		if (event == "CHAT_MSG_GUILD" and ct == "guild") then
			Quiz_ParseMessage("", arg2, arg1);
		end
		if (event == "CHAT_MSG_PARTY" and ct == "party") then
			Quiz_ParseMessage("", arg2, arg1);
		end
		if (event == "CHAT_MSG_SAY" and ct == "say") then
			Quiz_ParseMessage("", arg2, arg1);
		end

	result = nil
end


function Quiz_Print(msg)
	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage("|cffff9933" .. msg);
	end
end

function Quiz_Print_Table(tableToPrint)
	local printString_Holder = "";
	foreach(tableToPrint, 
		function(k,v) 
			--format "[Aircraft] [Geography] [Serial Killers] "
			--do not use | it causes sever problems when combined with n or r
			--ex: |n or |r act really strange
			-- \n to make new line
			local Temp_PrintString_Holder = "";
			printString_Holder = printString_Holder .. "[" .. v .. "] ";
			if (tableToPrint[k+1] ~= nil) then
				Temp_PrintString_Holder = printString_Holder .. "[" .. tableToPrint[k+1] .. "] ";
				if (string.len(Temp_PrintString_Holder)>55) then
					Quiz_Print(printString_Holder);
					printString_Holder = "";
				end
			else
				Quiz_Print(printString_Holder);
			end
		end);
end

function Quiz_OnUpdate() 	
	if (QuizData.state == QUIZ_STATE_STOPPED or
		QuizData.state == QUIZ_STATE_PAUSED) then
		return;
	elseif (QuizData.state == QUIZ_STATE_WAITING_TO_ASK) then
		if (GetTime() > QuizData.lastAction + QuizConfig.pauseBetweenQuestions) then
			Quiz_AskNewQuestion();
		end
	elseif (QuizData.state == QUIZ_STATE_ASKING) then
		if (QuizData.hint.currentHint == 0) then
			if (GetTime() > QuizData.lastAction + QuizConfig.firstHint) then
				Quiz_GiveHint();
			end
		else
			if (GetTime() > QuizData.lastAction + QuizConfig.nextHint) then
				Quiz_GiveHint();
			end
		end
	end
end


function Quiz_Broadcast(message, type, target)
	local clearAFK = GetCVar("autoClearAFK");
	SetCVar("autoClearAFK", 0);
	SendChatMessage("[QUIZ] " .. message, type, nil, target);
	SetCVar("autoClearAFK", clearAFK);
end

function Quiz_Fortune_Broadcast(message, type, target)
	local clearAFK = GetCVar("autoClearAFK");
	SetCVar("autoClearAFK", 0);
	SendChatMessage("[FORTUNE] " .. message, type, nil, target);
	SetCVar("autoClearAFK", clearAFK);
end

function Quiz_EightBall_Broadcast(message, type, target)
	local clearAFK = GetCVar("autoClearAFK");
	SetCVar("autoClearAFK", 0);
	SendChatMessage("[8BALL] " .. message, type, nil, target);
	SetCVar("autoClearAFK", clearAFK);
end

function Quiz_SendChannel(message)
	local ct = QuizConfig.channelType;
	if (ct == "guild" or ct == "raid" or ct == "party" or ct == "say") then
		Quiz_Broadcast(message, ct);
	else
        local channelNum = GetChannelName(QuizConfig.channel);
		if (channelNum ~= 0) then
			--local channelNum  = GetChannelName(QuizConfig.channel);
			Quiz_Broadcast(message, ct, channelNum);
		end
	end
end

function Quiz_SendWhisper(message, player) 
	Quiz_Broadcast(message, "WHISPER", player);
end

function Quiz_Fortune_SendWhisper(message, player) 
	Quiz_Fortune_Broadcast(message, "WHISPER", player);
end

function Quiz_EightBall_SendWhisper(message, player) 
	Quiz_EightBall_Broadcast(message, "WHISPER", player);
end

function Quiz_Whisper_Table(tableToPrint,sender)
	local printString_Holder = "";
	foreach(tableToPrint, 
		function(k,v) 
			local Temp_PrintString_Holder = "";
			printString_Holder = printString_Holder .. "[" .. v .. "] ";
			if (tableToPrint[k+1] ~= nil) then
				Temp_PrintString_Holder = printString_Holder .. "[" .. tableToPrint[k+1] .. "] ";
				--200 length for whispers
				if (string.len(Temp_PrintString_Holder)>200) then
					Quiz_SendWhisper(printString_Holder,sender);
					printString_Holder = "";
				end
			else
				Quiz_SendWhisper(printString_Holder,sender);
			end
		end);
end

function Quiz_ParseMessage(channel, sender, message)
	-- no channel yet? return
	if (not QuizConfig.channel) then
		return
	end

	local quizChannel = GetChannelName(QuizConfig.channel);
	Quiz_CheckAnswer(sender, message);
	
end


function checkAdmin(user)
--checks to see if user is an admin and returns true if s/he is
	local lUser = string.lower(user);
	local userIsAdmin = false;
	foreach(QuizConfig.admins,
		function(k,v)
			if (lUser == v) then
				userIsAdmin = true;
				return
			end
		end);
	return userIsAdmin;
end

function Quiz_DisplayScore(max)
	if (QuizData.state ~= QUIZ_STATE_STOPPED) then
		if (table.getn(QuizData.score) > 0) then
			Quiz_SortScores();
			local pos = 1;
			foreach(QuizData.score,
				function(k,v)
					if (pos <= max) then
						Quiz_SendChannel(pos .. ". " .. v.player .. " (" .. v.points .. " 道题)");
					end
					pos = pos + 1;
				end);
		else
			Quiz_SendChannel("目前无人得分……");
		end
	end

end

function Quiz_CheckAnswer(sender, answer)
	
	if (QuizData.currentQuestion == nil) then
		return;
	end

	if (QuizData.state ~= QUIZ_STATE_ASKING) then
		return;
	end

	if (Quiz_IsCorrect(QuizData.currentQuestion.AnswerAlt, answer, QuizData.currentQuestion.AnswerWild)) then
		local playerData = Quiz_GetPlayerData(sender);
		playerData.points = playerData.points + 1;
		

		Quiz_SendChannel(sender .. "给出了正确答案: " .. QuizData.currentQuestion.Answer .. ". " .. sender .. " 已答对总共 " .. playerData.points .. " 道题.");

		-- stop the game if this player has reached the maximum points
		if (playerData.points >= QuizConfig.pointsToWin) then
			Quiz_CmdStop();
			return;
		end
		
		-- missing modulus operator hack: every 5 questions print the score
		if (floor (QuizData.questionNumber / 5) == QuizData.questionNumber / 5) then
			Quiz_SendChannel("当前排行:");
			Quiz_DisplayScore(3);
		end
		
		QuizData.state = QUIZ_STATE_WAITING_TO_ASK;
		QuizData.lastAction = GetTime();


		local tempTable = {};
		--remove last question from QuizData.questionTable
		--QuizData.currentQuestionNumber
		foreach(QuizData.questionTable, 
				function(k,v) 
					if (k ~= QuizData.currentQuestionNumber) then
						table.insert(tempTable,v);
					else
						--do not insert
					end
				end);
		QuizData.questionTable = tempTable;
		--Quiz_Print("QuizData.questionTable length="..table.getn(QuizData.questionTable));


	end
end

function Quiz_GetPlayerData(name)
	local playerData;
	foreach(QuizData.score, 
		function(k,v) 
			if (v.player == name) then
				playerData = v;
			end
		end);
	if (not playerData) then
		playerData = {player = name, points = 0};
		table.insert(QuizData.score, playerData);
	end
	
	return playerData;
end



function Quiz_IsCorrect(solution, input, solutionWild) 

	local IsCorrect = false;
	foreach(solution, 
		function(k,v) 
			if (Quiz_Normalize(v) == Quiz_Normalize(input)) then
				IsCorrect = true;
			end
		end);

	return IsCorrect;

end


function Quiz_SortScores()
	table.sort(QuizData.score, function(a,b) return a.points > b.points end);
end


function Quiz_AskNewQuestion()
	QuizData.currentQuestion = Quiz_GetNewQuestion();
	if (QuizData.currentQuestion.Answer == "") then
		Quiz_HintInit(string.gsub(QuizData.currentQuestion.AnswerWild, ".*", "*"));
	else
		Quiz_HintInit(QuizData.currentQuestion.Answer);
	end
	
	QuizData.state = QUIZ_STATE_ASKING;
	QuizData.questionNumber = QuizData.questionNumber + 1;
	QuizData.lastAction = GetTime();
	
	if (string.len(QuizData.currentQuestion.Question) > 200) then
		Quiz_SendChannel("问: " .. string.sub(QuizData.currentQuestion.Question, 1, 200) .. "...");
		Quiz_SendChannel("..." .. string.sub(QuizData.currentQuestion.Question, 201));
	else 
		Quiz_SendChannel("问: " .. QuizData.currentQuestion.Question);
	end
end

function Quiz_CmdFortune(sender)
	if (not Quiz_Fortunes or table.getn(Quiz_Fortunes) == 0) then
		Quiz_Print("Error: No fortunes found in Fortunes.lua. Please download and install a valid fortune catalog.");
		return;
	end
	local rand = random(1, table.getn(Quiz_Fortunes));
	local msg = Quiz_Fortunes[rand];
	Quiz_Fortune_SendWhisper(msg, sender);
end

function Quiz_CmdEightBall(sender)
	if (not Quiz_8Ball or table.getn(Quiz_8Ball) == 0) then
		Quiz_Print("Error: No 8Ball answers found in 8Ball.lua. Please download and install a valid 8Ball catalog.");
		return;
	end
	local rand = random(1, table.getn(Quiz_8Ball));
	local msg = Quiz_8Ball[rand];
	Quiz_EightBall_SendWhisper(msg, sender);
end

function Quiz_CmdStart()
	if (QuizData.state == QUIZ_STATE_STOPPED) then
		if (not Quiz_Questions or table.getn(Quiz_Questions) == 0) then
			Quiz_Print("Error: No questions found in questions.lua. Please download and install a valid question catalog.");
			return;
		end
	
		QuizData.score = {};
		QuizData.questionNumber = 0;
		--Quiz_SendChannel("首先答对"..QuizConfig.pointsToWin.."道题的人为胜者,游戏开始... 祝你好运!");
		if (QuizConfig.genre ~= "none") then

			--loop, grab all questions of specific genre and add to QuizData.questionTable
			local Cat_Lowered = "";
			foreach(Quiz_Questions, 
				function(k,v) 
					Cat_Lowered = string.lower(v.Category);
					--if (GN == v.Category) then
					if (QuizConfig.genre == Cat_Lowered) then
						table.insert(QuizData.questionTable,v);
						--foundMatch = true;
						--Genre_Holder = v.Category;
						--return
					end
				end);

			Quiz_SendChannel("首先答对"..QuizConfig.pointsToWin.." 道题的人为胜者, 题库为"..QuizConfig.genre..",游戏现在开始... 祝你好运!");
		else

			--loop, grab all questions and add to QuizData.questionTable
			foreach(Quiz_Questions, 
				function(k,v) 
					table.insert(QuizData.questionTable,v);
				end);

			Quiz_SendChannel("首先答对 "..QuizConfig.pointsToWin.."道题的人为胜者,游戏开始... 祝你好运!");
		end
		QuizData.state = QUIZ_STATE_WAITING_TO_ASK;
		QuizData.lastAction = GetTime();
	end
end

function Quiz_CmdPause()
	if (QuizData.state ~= QUIZ_STATE_STOPPED) then
		if (QuizData.state == QUIZ_STATE_PAUSED) then
			-- resume
			Quiz_SendChannel("游戏继续.");
			QuizData.state = QUIZ_STATE_WAITING_TO_ASK;
			QuizData.lastAction = GetTime();
		else
			-- implicit solve
			Quiz_CmdSolve();
			Quiz_SendChannel("游戏已暂停. 请等待管理员恢复.");
			QuizData.state = QUIZ_STATE_PAUSED;
		end
	end
end


function Quiz_CmdStop()
	if (QuizData.state ~= QUIZ_STATE_STOPPED) then
		Quiz_SendChannel("游戏结束,多谢参与!");
		Quiz_SendChannel("比赛结果:");
		Quiz_DisplayScore(10);
		QuizData.state = QUIZ_STATE_STOPPED;
		QuizData.lastAction = GetTime();
		QuizData.questionTable = {};
	end
end

function Quiz_CmdResetScore()
	if (QuizData.state ~= QUIZ_STATE_STOPPED) then
		Quiz_SendChannel("分数已清零!请重新开始比赛.");
		QuizData.score = {};
	end
end

function Quiz_CmdSolve()
	if (QuizData.state == QUIZ_STATE_ASKING) then
		if (QuizData.currentQuestion.Answer == "") then
			Quiz_SendChannel("时间到. 正确答案是: " .. string.gsub(QuizData.currentQuestion.AnswerWild, ".*", "*"));
		else
			Quiz_SendChannel("时间到. 正确答案是: " .. QuizData.currentQuestion.Answer);
		end

		-- missing modulus operator hack: every 5 questions print the score
		if (floor (QuizData.questionNumber / 5) == QuizData.questionNumber / 5) then
			Quiz_SendChannel("当前排行:");
			Quiz_DisplayScore(3);
		end
		
		QuizData.state = QUIZ_STATE_WAITING_TO_ASK;
		QuizData.lastAction = GetTime();

		local tempTable = {};
		--remove last question from QuizData.questionTable
		--QuizData.currentQuestionNumber
		foreach(QuizData.questionTable, 
				function(k,v) 
					if (k ~= QuizData.currentQuestionNumber) then
						table.insert(tempTable,v);
					else
						--do not insert
					end
				end);
		QuizData.questionTable = tempTable;
		--Quiz_Print("QuizData.questionTable length="..table.getn(QuizData.questionTable));
	end
end

function Quiz_CmdStats()
	Quiz_SendChannel(table.getn(Quiz_Questions) .. " questions are in the database");
end

function Quiz_CmdChannel(channel)
	if (QuizData.state == QUIZ_STATE_STOPPED) then
		--chanUpper is actually channel lowercase.  just too lazy to go back and change
		local chanUpper = string.lower(channel);
		--if (channel=="guild" or channel=="raid" or channel=="party") then
		if (chanUpper=="guild" or chanUpper=="raid" or chanUpper=="party" or chanUpper=="say") then
			Quiz_Mod_Save[QuizConfig.profile].channelType = chanUpper;
			QuizConfig.channelType = Quiz_Mod_Save[QuizConfig.profile].channelType;
			Quiz_Print("Channel set to " .. chanUpper);
		else
			Quiz_Mod_Save[QuizConfig.profile].channel = chanUpper;
			QuizConfig.channel = Quiz_Mod_Save[QuizConfig.profile].channel;
			Quiz_Mod_Save[QuizConfig.profile].channelType = "channel";
			QuizConfig.channelType = Quiz_Mod_Save[QuizConfig.profile].channelType;
			Quiz_Print("Channel set to " .. channel .. ". Make sure that you join this channel.");
		end
	else
		Quiz_Print("Channel cannot be changed while a quiz is in session.");
	end
end

function Quiz_CmdPointsToWin(pts,userAdm)
	if (QuizData.state == QUIZ_STATE_STOPPED) then
		local newPoints = tonumber(pts);
		--local newPoints = pts;
		if (newPoints ~= nil) then
			Quiz_Mod_Save[QuizConfig.profile].pointsToWin = newPoints;
			QuizConfig.pointsToWin = Quiz_Mod_Save[QuizConfig.profile].pointsToWin;
			--if (QuizData.state ~= QUIZ_STATE_STOPPED and QuizData.state ~= QUIZ_STATE_PAUSED) then
			--	Quiz_SendChannel("玩家需要答对 "..newPoints.." 道题来获取胜利");
			--else
			if (userAdm == 0) then
				Quiz_Print("玩家需要答对 "..newPoints.."道题来获取胜利");
			elseif (userAdm == 1) then
				Quiz_SendChannel("玩家需要答对"..newPoints.."道题来获取胜利");
			end
			--end
		else
			if (userAdm == 0) then
				Quiz_Print("请输入获胜所需答对题数");
			elseif (userAdm == 1) then
				--Quiz_SendWhisper("Current Question: " .. QuizData.currentQuestion.Question, sender);
				Quiz_SendChannel("请输入获胜所需答对题数");
			end
		end
	else
		if (userAdm == 0) then
			Quiz_Print("无法在游戏进行中更改胜利条件.");
		elseif (userAdm == 1) then
			Quiz_SendChannel("无法在游戏进行中更改胜利条件.");
		end
	end
end

function Quiz_CmdMaxHints(hintAmt,userAdm)
	if (QuizData.state == QUIZ_STATE_STOPPED) then
		local newHintAmt = tonumber(hintAmt);
		if (newHintAmt ~= nil) then
			QuizConfig.maxHints = newHintAmt;
			Quiz_Mod_Save[QuizConfig.profile].maxHints = QuizConfig.maxHints;
			--QuizConfig.pointsToWin = Quiz_Mod_Save[QuizConfig.profile].pointsToWin;
			--if (QuizData.state ~= QUIZ_STATE_STOPPED and QuizData.state ~= QUIZ_STATE_PAUSED) then
			if (userAdm == 0) then
				Quiz_Print("玩家在系统给出答案前共获得 "..newHintAmt.." 次提示");
			elseif (userAdm == 1) then
				Quiz_SendChannel("玩家在系统给出答案前共获得"..newHintAmt.." 次提示");
			end
		else
			Quiz_Print("请给出提示次数");
		end
	else
		if (userAdm == 0) then
			Quiz_Print("无法在游戏进行中更改提示次数.");
		elseif (userAdm == 1) then
			Quiz_SendChannel("无法在游戏进行中更改提示次数.");
		end
	end
end

function Quiz_CmdChangeGenre(newGenre,userAdm)
--**remove ability to change genre during a game**
	if (QuizData.state == QUIZ_STATE_STOPPED) then
		local GN = string.lower(newGenre);
		local Cat_Lowered = "";
		local Genre_Holder = "";
		if (GN == "none") then
			QuizConfig.genre = GN;
			Quiz_Mod_Save[QuizConfig.profile].genre = QuizConfig.genre;
			if (userAdm==0) then
				Quiz_Print("问题将在总题库中随机抽取.");
			elseif (userAdm==1) then
				Quiz_SendChannel("问题将在总题库中随机抽取.");
			end
		elseif (GN ~= nil and GN ~= "") then
			local foundMatch = false;
			foreach(Quiz_Questions, 
				function(k,v) 
					Cat_Lowered = string.lower(v.Category);
					--if (GN == v.Category) then
					if (GN == Cat_Lowered) then
						foundMatch = true;
						Genre_Holder = v.Category;
						return
					end
				end);
			if (foundMatch == true) then
				QuizConfig.genre = Genre_Holder;
				Quiz_Mod_Save[QuizConfig.profile].genre = QuizConfig.genre;
				if (userAdm==0) then
					Quiz_Print("题库选定为 "..QuizConfig.genre);
				elseif (userAdm==1) then
					Quiz_SendChannel("题库选定为"..QuizConfig.genre);
				end
			else
				if (userAdm==0) then
					Quiz_Print(newGenre.."不是一个有效的题库名. "..QuizConfig.genre.." 是目前所加载的题库.");
				elseif (userAdm==1) then
					Quiz_SendChannel(newGenre.." 不是一个有效的题库名. "..QuizConfig.genre.."是目前所加载的题库.");
				end
			end
		end
	else
		if (userAdm==0) then
			Quiz_Print("无法在游戏进行中更改题库类型.");
		elseif (userAdm==1) then
			Quiz_SendChannel("无法在游戏进行中更改题库类型.");
		end
	end
end

function Quiz_CmdShowGenres() 
	local Genre_Holder = {};
	local Genre_Temp = "";
	foreach(Quiz_Questions, 
		function(k,v) 
			local Found_Same_Genre = false;
			--Genre_Temp = v.Category;
			Genre_Temp = string.lower(v.Category);
			foreach(Genre_Holder, 
				function(k2,v2)
					if (string.lower(v2) == Genre_Temp) then
						Found_Same_Genre = true;
						return
					end
				end);
			if (Found_Same_Genre == false) then
				table.insert(Genre_Holder,v.Category);
			end
		end);
	table.sort(Genre_Holder);
	Quiz_Print("Genres available:")
	Quiz_Print_Table(Genre_Holder);
end

function Quiz_CmdWhisperGenres(sender) 
	local Genre_Holder = {};
	local Genre_Temp = "";
	foreach(Quiz_Questions, 
		function(k,v) 
			local Found_Same_Genre = false;
			Genre_Temp = string.lower(v.Category);
			foreach(Genre_Holder, 
				function(k2,v2)
					if (string.lower(v2) == Genre_Temp) then
						Found_Same_Genre = true;
						return
					end
				end);
			if (Found_Same_Genre == false) then
				table.insert(Genre_Holder,v.Category);
			end
		end);
	Quiz_SendWhisper("Genres available:",sender);
	Quiz_Whisper_Table(Genre_Holder,sender);
end

function Quiz_CmdMakeAdmin(user)
	local lUser = string.lower(user);
	local Found_Same_User = false;
	--check for match.  if none found, add to table
	foreach(QuizConfig.admins, 
		function(k,v)
			if (string.lower(v) == lUser) then
				Found_Same_User = true;
				return
			end
		end);
	if (Found_Same_User == false) then
		table.insert(QuizConfig.admins,lUser);
		table.sort(QuizConfig.admins);
		Quiz_Mod_Save[QuizConfig.profile].admins = QuizConfig.admins;
		Quiz_Print(lUser.." 获得管理权限");
	else
		Quiz_Print(lUser.." 已获得管理权限");
	end
end

function Quiz_CmdChangeSpeed(spd)
	if (QuizData.state == QUIZ_STATE_STOPPED) then
		local nSpd = string.lower(spd);
		if (nSpd=="slow") then
			QuizConfig.speed="slow";
			QuizConfig.pauseBetweenQuestions=Quiz_Slow_PauseBetween;
			QuizConfig.firstHint=Quiz_Slow_FirstHint;
			QuizConfig.nextHint=Quiz_Slow_NextHint;
			Quiz_Print("游戏速度被设定为 慢速.");
			--save
			Quiz_Mod_Save[QuizConfig.profile].speed = QuizConfig.speed;
			Quiz_Mod_Save[QuizConfig.profile].pauseBetweenQuestions = QuizConfig.pauseBetweenQuestions;
			Quiz_Mod_Save[QuizConfig.profile].firstHint = QuizConfig.firstHint;
			Quiz_Mod_Save[QuizConfig.profile].nextHint = QuizConfig.nextHint;
		elseif (nSpd=="medium") then
			QuizConfig.speed="medium";
			QuizConfig.pauseBetweenQuestions=Quiz_Medium_PauseBetween;
			QuizConfig.firstHint=Quiz_Medium_FirstHint;
			QuizConfig.nextHint=Quiz_Medium_NextHint;
			Quiz_Print("游戏速度被设定为 中速.");
			--save
			Quiz_Mod_Save[QuizConfig.profile].speed = QuizConfig.speed;
			Quiz_Mod_Save[QuizConfig.profile].pauseBetweenQuestions = QuizConfig.pauseBetweenQuestions;
			Quiz_Mod_Save[QuizConfig.profile].firstHint = QuizConfig.firstHint;
			Quiz_Mod_Save[QuizConfig.profile].nextHint = QuizConfig.nextHint;
		elseif (nSpd=="fast") then
			QuizConfig.speed="fast";
			QuizConfig.pauseBetweenQuestions=Quiz_Fast_PauseBetween;
			QuizConfig.firstHint=Quiz_Fast_FirstHint;
			QuizConfig.nextHint=Quiz_Fast_NextHint;
			Quiz_Print("游戏速度被设定为 快速.");
			--save
			Quiz_Mod_Save[QuizConfig.profile].speed = QuizConfig.speed;
			Quiz_Mod_Save[QuizConfig.profile].pauseBetweenQuestions = QuizConfig.pauseBetweenQuestions;
			Quiz_Mod_Save[QuizConfig.profile].firstHint = QuizConfig.firstHint;
			Quiz_Mod_Save[QuizConfig.profile].nextHint = QuizConfig.nextHint;
		else
			Quiz_Print("输入英文 slow [慢速], medium [中速], 或者 fast [快速] 来调节游戏速度.");
		end
	else
		Quiz_Print("游戏中不可调节速度.");
	end
end

function Quiz_CmdRemoveAdmin(user)
	local lUser = string.lower(user);
	local adminHolder = {};
	local userRemoved = false;
	foreach(QuizConfig.admins, 
		function(k,v)
			if (v == lUser) then
				userRemoved = true;
				--return
			else
				table.insert(adminHolder,v);
			end
		end);
	if (userRemoved) then
		QuizConfig.admins = adminHolder;
		Quiz_Mod_Save[QuizConfig.profile].admins = QuizConfig.admins;
		Quiz_Print(user.."管理权限已取消");
	else
		Quiz_Print(user.." 没有在管理员列表内");
	end
end

function Quiz_CmdShowAdmins()
	Quiz_Print("Admin list:");
	Quiz_Print_Table(QuizConfig.admins);
end

function Quiz_CmdClearAllAdmins()
	QuizConfig.admins = {};
	Quiz_Mod_Save[QuizConfig.profile].admins = QuizConfig.admins;
	Quiz_Print("Admin list cleared");
end

function Quiz_CmdToggleAdminCommands()
	if (QuizConfig.adminCommands=="off") then
		QuizConfig.adminCommands="on";
		Quiz_Mod_Save[QuizConfig.profile].adminCommands = QuizConfig.adminCommands;
	else
		QuizConfig.adminCommands="off";
		Quiz_Mod_Save[QuizConfig.profile].adminCommands = QuizConfig.adminCommands;
	end
	Quiz_Print("Admin commands are currently "..QuizConfig.adminCommands);
end

function Quiz_CmdToggleFortunes()
	if (QuizConfig.fortunes=="off") then
		QuizConfig.fortunes="on";
		Quiz_Mod_Save[QuizConfig.profile].fortunes = QuizConfig.fortunes;
	else
		QuizConfig.fortunes="off";
		Quiz_Mod_Save[QuizConfig.profile].fortunes = QuizConfig.fortunes;
	end
	Quiz_Print("Fortunes are currently "..QuizConfig.fortunes);
end

function Quiz_CmdToggleEightBall()
	if (QuizConfig.eightBall=="off") then
		QuizConfig.eightBall="on";
		Quiz_Mod_Save[QuizConfig.profile].eightBall = QuizConfig.eightBall;
	else
		QuizConfig.eightBall="off";
		Quiz_Mod_Save[QuizConfig.profile].eightBall = QuizConfig.eightBall;
	end
	Quiz_Print("8Ball is currently "..QuizConfig.eightBall);
end

function Quiz_CmdStatus()
	if (QuizConfig.channelType == "channel") then
		Quiz_Print("Channel: "..QuizConfig.channel);
	else
		Quiz_Print("Channel: "..QuizConfig.channelType);
	end
	Quiz_Print("胜利所需题数: "..QuizConfig.pointsToWin);
	Quiz_Print("题库类型: "..QuizConfig.genre);
	Quiz_Print("最多提示次数: "..QuizConfig.maxHints);
	Quiz_Print("游戏速度: "..QuizConfig.speed);
	Quiz_Print("控制命令: "..QuizConfig.adminCommands);
	Quiz_Print("算命组件: "..QuizConfig.fortunes);
	Quiz_Print("幸运8号球: "..QuizConfig.eightBall);
end

function Quiz_CmdClear()
	Quiz_CmdStop();
	Quiz_Mod_Save[QuizConfig.profile] = nil;
	QuizConfig.channel = "quiz";
	QuizConfig.channelType = "channel";
	QuizConfig.pointsToWin = 10;
	QuizConfig.maxHints = 6;
	QuizConfig.speed="medium";
	QuizConfig.pauseBetweenQuestions=Quiz_Medium_PauseBetween;
	QuizConfig.firstHint=Quiz_Medium_FirstHint;
	QuizConfig.nextHint=Quiz_Medium_NextHint;
	QuizConfig.genre = "none";
	QuizConfig.adminCommands="on";
	QuizConfig.fortunes="on";
	QuizConfig.eightBall="on";
	Quiz_Print("游戏设定已恢复初始值,管理员列表未归零.");
	QUIZVARIABLES_LOADED = false;
end

function Quiz_CmdHelp()
	--Quiz_Print("Quiz问答插件 " .. QUIZ_VERSION .. " 由Bru和 Hayward 制作(德国) Sheery 汉化 x00s 修正");
	Quiz_Print("使用说明:");
	Quiz_Print("  /quiz channel <name> - 更改提问频道 (raid 团队, guild 工会, party 小队, say 说, or YourOwn)");
	Quiz_Print("  /quiz pointstowin <#> - 设定获胜所需答对题数");
	Quiz_Print("  /quiz maxhints <#> - 设定系统提示次数");
	Quiz_Print("  /quiz speed <*> - 设定游戏速度(slow, medium, fast)");
	Quiz_Print("  /quiz changegenre <题库名> - 设定题库类别(使用 <none> 可以调用总题库)");
	Quiz_Print("  /quiz showgenres - 显示题库列表");
	Quiz_Print("  /quiz start - 开始新游戏");
	Quiz_Print("  /quiz stop - 立即结束当前游戏");
	Quiz_Print("  /quiz pause - 游戏暂停或继续");
	Quiz_Print("  /quiz hint - 当前问题手动给出提示");
	Quiz_Print("  /quiz solve - 当前问题手动给出答案");
	Quiz_Print("  /quiz resetscore - 清空记分板");
	Quiz_Print("  /quiz makeadmin <用户名> - 给予<用户名> 管理权限");
	Quiz_Print("  /quiz removeadmin <用户名> - 移除 <用户名> 的管理权限");
	Quiz_Print("  /quiz clearalladmins - 清空管理员列表");
	Quiz_Print("  /quiz showadmins - 显示当前所有管理员");
	Quiz_Print("  /quiz toggleadmincommands - 开启管理员操作");
	Quiz_Print("  /quiz stats - 显示当前问答相关信息");
	Quiz_Print("  /quiz status - 显示UI相关信息");
	Quiz_Print("  /quiz clear - 清除所有记录讯息");
end

function Quiz_CmdWhisperHelp(sender,admOrNot)
	--Quiz_Print("Quiz " .. QUIZ_VERSION .. " by Bru and Hayward on Blackhand(DE)");
	if (admOrNot == 1) then
		Quiz_SendWhisper("Quiz Admin commands:",sender);
		Quiz_SendWhisper("  !pointstowin <#> - sets the points needed to win to a new amount",sender);
		Quiz_SendWhisper("  !maxhints <#> - sets how many hints are given before auto solve",sender);
		Quiz_SendWhisper("  !changegenre <genretitle> - sets the quiz question genre (use <none> to allow quiz questions from all genres)",sender);
		Quiz_SendWhisper("  !showgenres - displays available genres",sender);
		Quiz_SendWhisper("  !start - starts a quiz game",sender);
		Quiz_SendWhisper("  !stop - ends the current game",sender);
		Quiz_SendWhisper("  !pause - pauses / resumes a quiz game",sender);
		Quiz_SendWhisper("  !question - whispers you the current question",sender);
		Quiz_SendWhisper("  !score - displays a score tally",sender);
		Quiz_SendWhisper("  !fortune - get your fortune told",sender);
        Quiz_SendWhisper("  !8ball - get an answer to a question",sender);
	else
		Quiz_SendWhisper("Quiz User commands:",sender);
		Quiz_SendWhisper("  !question - whispers you the current question",sender);
		Quiz_SendWhisper("  !score - displays a score tally",sender);
		Quiz_SendWhisper("  !fortune - get your fortune told",sender);
        Quiz_SendWhisper("  !8ball - get an answer to a question",sender);
	end
end

function Quiz_Normalize(text)
	text = string.gsub(text, "\195\164", "ae");
	text = string.gsub(text, "\195\182", "oe");
	text = string.gsub(text, "\195\188", "ue");
	text = string.gsub(text, "\195\132", "AE");
	text = string.gsub(text, "\195\150", "OE");
	text = string.gsub(text, "\195\156", "UE");
	text = string.gsub(text, "\195\159", "ss");
	text = string.gsub(text, "[^%S]", "");
	text = string.lower(text)
	return text;
end

function Quiz_CmdHint()
	Quiz_GiveHint();
end

function Quiz_GetNewQuestion()
--don't need separate ifs for genre and none anymore.  put both together.
--if QuizData.questionTable is now empty, repopulate it.  be sure to check genre or not
	if (table.getn(QuizData.questionTable) ~= 0) then
		local rand = random(1, table.getn(QuizData.questionTable));
		QuizData.currentQuestionNumber = rand;
		return QuizData.questionTable[rand];
	else
		if (QuizConfig.genre ~= "none") then
			--loop, grab all questions of specific genre and add to QuizData.questionTable
			local Cat_Lowered = "";
			local genreLowered = string.lower(QuizConfig.genre);
			foreach(Quiz_Questions, 
				function(k,v) 
					Cat_Lowered = string.lower(v.Category);
					if (genreLowered == Cat_Lowered) then
						table.insert(QuizData.questionTable,v);
					end
				end);
		else
			--loop, grab all questions and add to QuizData.questionTable
			foreach(Quiz_Questions, 
				function(k,v) 
					table.insert(QuizData.questionTable,v);
				end);
		end
		local rand = random(1, table.getn(QuizData.questionTable));
		QuizData.currentQuestionNumber = rand;
		return QuizData.questionTable[rand];
	end
end


function Quiz_GiveHint()
	-- solve the questions when there are no more hints to display
	if (QuizData.hint ~= nil) then
		if (QuizData.hint.currentHint >= QuizData.hint.hintCount - 1 and QuizData.state == QUIZ_STATE_ASKING) then
		--if (QuizData.hint.currentHint >= QuizData.hint.hintCount) then
			Quiz_CmdSolve();
		else
			if (QuizData.state == QUIZ_STATE_ASKING) then
				Quiz_SendChannel("提示: " .. Quiz_GetNextHint());
				QuizData.lastAction = GetTime();
			end
		end
	end
end

function Quiz_HintInit(text)
	QuizData.hint = {
		chars = {},
		numRevealed = 0,
		numRevealable = 0,
		hintCount = 0,
		currentHint = 0,
	};
	
	text = string.gsub(text, "#", ""); 
	
	local hint = QuizData.hint;
	
	local pos = 1;
	local length = string.len(text);
	while (pos <= length) do
		local charData = {
			revealed = false;
			revealable = false;
		};
		charData.value = string.sub(text, pos, pos);
		--if (string.find(charData.value, "%S")) then
		if (string.find(charData.value, "%S+")) then
			charData.revealable = true;
			hint.numRevealable = hint.numRevealable + 1;
		end
		table.insert(hint.chars, charData);
		pos = pos + 1;
	end
	
	if (hint.numRevealable < QuizConfig.maxHints) then
		--hint.hintCount = hint.numRevealable - 1;
		hint.hintCount = hint.numRevealable;
	else
		hint.hintCount = QuizConfig.maxHints+1;
	end
	
end

function Quiz_GetNextHint()
	local hint = QuizData.hint;
	
	hint.currentHint = hint.currentHint + 1;
	local numRevealedAfter = math.floor((hint.currentHint / hint.hintCount) * hint.numRevealable + 0.5);

	local numToReveal = numRevealedAfter - hint.numRevealed;

	-- reveal more characters
	for i = 1, numToReveal, 1 do
		local numUnrevealed = hint.numRevealable - hint.numRevealed;
		local revealChar = math.random(1, numUnrevealed);
		
		local currentChar = 1;
		for useless, charData in pairs(hint.chars) do
			if (charData.revealable and not charData.revealed) then
				if (currentChar == revealChar) then
					charData.revealed = true;
					hint.numRevealed = hint.numRevealed + 1;
					break;
				else 
					currentChar = currentChar + 1;
				end
			end
		end
	end
	
	-- build the hint text
	local hintText = "";
	for useless, charData in pairs(hint.chars) do
		if (not charData.revealable or charData.revealed) then
			hintText = hintText .. charData.value;
		else
			hintText = hintText .. "*";
		end
	end	
	
	return hintText;
	
end

function Quiz_LoadVariables()
	if QUIZVARIABLES_LOADED then
		return;
	end

	QuizConfig.player = UnitName("player");
	QuizConfig.realm = GetCVar("RealmName");
	QuizConfig.profile = QuizConfig.player.." of "..QuizConfig.realm;

	if Quiz_Mod_Save[QuizConfig.profile] == nil then
		Quiz_Mod_Save[QuizConfig.profile] = {}
	end

	if Quiz_Mod_Save[QuizConfig.profile].channel == nil then
		Quiz_Mod_Save[QuizConfig.profile].channel = QuizConfig.channel;
	end
	if Quiz_Mod_Save[QuizConfig.profile].channelType == nil then
		Quiz_Mod_Save[QuizConfig.profile].channelType = QuizConfig.channelType;
	end
	if Quiz_Mod_Save[QuizConfig.profile].pointsToWin == nil then
		Quiz_Mod_Save[QuizConfig.profile].pointsToWin = QuizConfig.pointsToWin;
	end
	if Quiz_Mod_Save[QuizConfig.profile].maxHints == nil then
		Quiz_Mod_Save[QuizConfig.profile].maxHints = QuizConfig.maxHints;
	end
	if Quiz_Mod_Save[QuizConfig.profile].genre == nil then
		Quiz_Mod_Save[QuizConfig.profile].genre = QuizConfig.genre;
	end
	if Quiz_Mod_Save[QuizConfig.profile].adminCommands == nil then
		Quiz_Mod_Save[QuizConfig.profile].adminCommands = QuizConfig.adminCommands;
	end
	if Quiz_Mod_Save[QuizConfig.profile].fortunes == nil then
		Quiz_Mod_Save[QuizConfig.profile].fortunes = QuizConfig.fortunes;
	end
	if Quiz_Mod_Save[QuizConfig.profile].eightBall == nil then
		Quiz_Mod_Save[QuizConfig.profile].eightBall = QuizConfig.eightBall;
	end
	if Quiz_Mod_Save[QuizConfig.profile].admins == nil then
		Quiz_Mod_Save[QuizConfig.profile].admins = QuizConfig.admins;
	end
	if Quiz_Mod_Save[QuizConfig.profile].speed == nil then
		Quiz_Mod_Save[QuizConfig.profile].speed = QuizConfig.speed;
	end
	if Quiz_Mod_Save[QuizConfig.profile].pauseBetweenQuestions == nil then
		Quiz_Mod_Save[QuizConfig.profile].pauseBetweenQuestions = QuizConfig.pauseBetweenQuestions;
	end
	if Quiz_Mod_Save[QuizConfig.profile].firstHint == nil then
		Quiz_Mod_Save[QuizConfig.profile].firstHint = QuizConfig.firstHint;
	end
	if Quiz_Mod_Save[QuizConfig.profile].nextHint == nil then
		Quiz_Mod_Save[QuizConfig.profile].nextHint = QuizConfig.nextHint;
	end

	QuizConfig.channel = Quiz_Mod_Save[QuizConfig.profile].channel;
	QuizConfig.channelType = Quiz_Mod_Save[QuizConfig.profile].channelType;
	QuizConfig.pointsToWin = Quiz_Mod_Save[QuizConfig.profile].pointsToWin;
	QuizConfig.maxHints = Quiz_Mod_Save[QuizConfig.profile].maxHints;
	QuizConfig.genre = Quiz_Mod_Save[QuizConfig.profile].genre;
	QuizConfig.adminCommands = Quiz_Mod_Save[QuizConfig.profile].adminCommands;
	QuizConfig.fortunes = Quiz_Mod_Save[QuizConfig.profile].fortunes;
	QuizConfig.eightBall = Quiz_Mod_Save[QuizConfig.profile].eightBall;
	QuizConfig.admins = Quiz_Mod_Save[QuizConfig.profile].admins;
	QuizConfig.speed = Quiz_Mod_Save[QuizConfig.profile].speed;
	QuizConfig.pauseBetweenQuestions = Quiz_Mod_Save[QuizConfig.profile].pauseBetweenQuestions;
	QuizConfig.firstHint = Quiz_Mod_Save[QuizConfig.profile].firstHint;
	QuizConfig.nextHint = Quiz_Mod_Save[QuizConfig.profile].nextHint;

	--QuizConfig.VARIABLES_LOADED = true;
	QUIZVARIABLES_LOADED = true;
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", Quiz_OnEvent)
ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", Quiz_OnEvent)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", Quiz_OnEvent)
ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", Quiz_OnEvent)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", Quiz_OnEvent)